Index: trunk/sources/HeuristicLab.Selection/3.3/RandomSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/RandomSelector.cs	(revision 2803)
+++ trunk/sources/HeuristicLab.Selection/3.3/RandomSelector.cs	(revision 2805)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -20,37 +20,32 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Selection {
   /// <summary>
-  /// Copies or moves a defined number of sub scopes from a source scope to a target scope, being selected
-  /// randomly.
+  /// A random selection operator.
   /// </summary>
-  public class RandomSelector : StochasticSelectorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
+  [Item("RandomSelector", "A random selection operator.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class RandomSelector : StochasticSelector {
+    public RandomSelector() : base() { }
 
-    /// <summary>
-    /// Copies or moves a number of sub scopes (<paramref name="selected"/>) from <paramref name="source"/>
-    /// to the <paramref name="target"/>, chosen randomly.
-    /// </summary>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="source">The source scope from which to copy/move the sub scopes.</param>
-    /// <param name="selected">The number of sub scopes to move.</param>
-    /// <param name="target">The target where to copy/move the sub scopes.</param>
-    /// <param name="copySelected">Boolean flag whether the sub scopes shall be copied or moved.</param>
-    protected override void Select(IRandom random, IScope source, int selected, IScope target, bool copySelected) {
-      for (int i = 0; i < selected; i++) {
-        if (copySelected) {
-          target.AddSubScope((IScope)source.SubScopes[random.Next(source.SubScopes.Count)].Clone());
-        } else {
-          IScope s = source.SubScopes[random.Next(source.SubScopes.Count)];
-          source.RemoveSubScope(s);
-          target.AddSubScope(s);
+    protected override void Select(ScopeList source, ScopeList target) {
+      int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
+      bool copy = CopySelectedParameter.Value.Value;
+      IRandom random = RandomParameter.ActualValue;
+
+      for (int i = 0; i < count; i++) {
+        if (copy)
+          target.Add((IScope)source[random.Next(source.Count)].Clone());
+        else {
+          int index = random.Next(source.Count);
+          target.Add(source[index]);
+          source.RemoveAt(index);
         }
       }
Index: trunk/sources/HeuristicLab.Selection/3.3/RightSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/RightSelector.cs	(revision 2803)
+++ trunk/sources/HeuristicLab.Selection/3.3/RightSelector.cs	(revision 2805)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -20,42 +20,33 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Selection {
   /// <summary>
-  /// Copies or moves a defined number of sub scopes from a source scope to a target scope, starting at
-  /// the right side of the tree.
+  /// An operator which selects sub-scopes from right to left.
   /// </summary>
-  public class RightSelector : StochasticSelectorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
+  [Item("RightSelector", "An operator which selects sub-scopes from right to left.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class RightSelector : Selector {
+    public RightSelector() : base() { }
 
-    /// <summary>
-    /// Copies or moves a number of sub scopes (<paramref name="selected"/>) from <paramref name="source"/>
-    /// starting at the right end to the <paramref name="target"/>.
-    /// </summary>
-    /// <param name="random">A random number generator.</param>
-    /// <param name="source">The source scope from which to copy/move the sub scopes.</param>
-    /// <param name="selected">The number of sub scopes to move. Can be also bigger than the total 
-    /// number of sub scopes in <paramref name="source"/>, then the copying process starts again from the 
-    /// beginning.</param>
-    /// <param name="target">The target where to copy/move the sub scopes.</param>
-    /// <param name="copySelected">Boolean flag whether the sub scopes shall be copied or moved.</param>
-    protected override void Select(IRandom random, IScope source, int selected, IScope target, bool copySelected) {
-      int index = source.SubScopes.Count - 1;
-      for (int i = 0; i < selected; i++) {
-        if (copySelected) {
-          target.AddSubScope((IScope)source.SubScopes[index].Clone());
-          index--;
-          if (index < 0) index = source.SubScopes.Count - 1;
+    protected override void Select(ScopeList source, ScopeList target) {
+      int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
+      bool copy = CopySelectedParameter.Value.Value;
+
+      int j = source.Count - 1;
+      for (int i = 0; i < count; i++) {
+        if (copy) {
+          target.Add((IScope)source[j].Clone());
+          j--;
+          if (j < 0) j = source.Count - 1;
         } else {
-          IScope s = source.SubScopes[source.SubScopes.Count - 1];
-          source.RemoveSubScope(s);
-          target.AddSubScope(s);
+          target.Add(source[source.Count - 1]);
+          source.RemoveAt(source.Count - 1);
         }
       }
Index: trunk/sources/HeuristicLab.Selection/3.3/Selector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 2805)
@@ -0,0 +1,83 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Selection {
+  /// <summary>
+  /// A base class for selection operators.
+  /// </summary>
+  [Item("Selector", "A base class for selection operators.")]
+  [EmptyStorableClass]
+  public abstract class Selector : SingleSuccessorOperator {
+    protected ValueParameter<BoolData> CopySelectedParameter {
+      get { return (ValueParameter<BoolData>)Parameters["CopySelected"]; }
+    }
+    public ValueLookupParameter<IntData> NumberOfSelectedSubScopesParameter {
+      get { return (ValueLookupParameter<IntData>)Parameters["NumberOfSelectedSubScopes"]; }
+    }
+    protected ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+
+    public BoolData CopySelected {
+      get { return CopySelectedParameter.Value; }
+      set { CopySelectedParameter.Value = value; }
+    }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+
+    protected Selector()
+      : base() {
+      Parameters.Add(new ValueParameter<BoolData>("CopySelected", "True if the selected sub-scopes should be copied, otherwise false.", new BoolData(false)));
+      Parameters.Add(new ValueLookupParameter<IntData>("NumberOfSelectedSubScopes", "The number of sub-scopes which should be selected."));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope from which sub-scopes should be selected."));
+    }
+
+    public sealed override IExecutionSequence Apply() {
+      ScopeList source = new ScopeList(CurrentScope.SubScopes);
+      ScopeList target = new ScopeList();
+
+      Select(source, target);
+
+      CurrentScope.SubScopes.Clear();
+      IScope remaining = new Scope("Remaining");
+      CurrentScope.SubScopes.Add(remaining);
+      IScope selected = new Scope("Selected");
+      CurrentScope.SubScopes.Add(selected);
+
+      for (int i = 0; i < source.Count; i++)
+        remaining.SubScopes.Add(source[i]);
+      for (int i = 0; i < target.Count; i++)
+        selected.SubScopes.Add(target[i]);
+
+      return base.Apply();
+    }
+
+    protected abstract void Select(ScopeList source, ScopeList target);
+  }
+}
Index: trunk/sources/HeuristicLab.Selection/3.3/StochasticSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/StochasticSelector.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Selection/3.3/StochasticSelector.cs	(revision 2805)
@@ -0,0 +1,44 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Selection {
+  /// <summary>
+  /// A base class for stochastic selection operators.
+  /// </summary>
+  [Item("StochasticSelector", "A base class for stochastic selection operators.")]
+  [EmptyStorableClass]
+  public abstract class StochasticSelector : Selector {
+    public LookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    protected StochasticSelector()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator used for stochastic selection."));
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Selection/3.3/StochasticSingleObjectiveSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/StochasticSingleObjectiveSelector.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Selection/3.3/StochasticSingleObjectiveSelector.cs	(revision 2805)
@@ -0,0 +1,48 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Selection {
+  /// <summary>
+  /// A base class for stochastic selection operators which consider a single double quality value for selection.
+  /// </summary>
+  [Item("StochasticSingleObjectiveSelector", "A base class for stochastic selection operators which consider a single double quality value for selection.")]
+  [EmptyStorableClass]
+  public abstract class StochasticSingleObjectiveSelector : StochasticSelector {
+    public LookupParameter<BoolData> MaximizationParameter {
+      get { return (LookupParameter<BoolData>)Parameters["Maximization"]; }
+    }
+    public SubScopesLookupParameter<DoubleData> QualityParameter {
+      get { return (SubScopesLookupParameter<DoubleData>)Parameters["Quality"]; }
+    }
+
+    protected StochasticSingleObjectiveSelector()
+      : base() {
+      Parameters.Add(new LookupParameter<BoolData>("Maximization", "True if the current problem is a maximization problem, otherwise false."));
+      Parameters.Add(new SubScopesLookupParameter<DoubleData>("Quality", "The quality value contained in each sub-scope which is used for selection."));
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 2803)
+++ trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 2805)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -20,68 +20,51 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Selection {
   /// <summary>
-  /// Moves or copies a defined number of the best sub scopes from a source scope to a target scope.
+  /// A tournament selection operator which considers a single double quality value for selection.
   /// </summary>
-  public class TournamentSelector : StochasticSelectorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
+  [Item("TournamentSelector", "A tournament selection operator which considers a single double quality value for selection.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class TournamentSelector : StochasticSingleObjectiveSelector {
+    public ValueLookupParameter<IntData> GroupSizeParameter {
+      get { return (ValueLookupParameter<IntData>)Parameters["GroupSize"]; }
     }
 
-    /// <summary>
-    /// Initializes a new instance of <see cref="TournamentSelector"/> with three variable infos 
-    /// (<c>Maximization</c>, <c>Quality</c> and <c>GroupSize</c>, being a local variable and set to 
-    /// <c>2</c>) with <c>CopySelected</c> set to <c>true</c>.
-    /// </summary>
-    public TournamentSelector() {
-      AddVariableInfo(new VariableInfo("Maximization", "Maximization problem", typeof(BoolData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("Quality", "Quality value", typeof(DoubleData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("GroupSize", "Size of the tournament group", typeof(IntData), VariableKind.In));
-      GetVariableInfo("GroupSize").Local = true;
-      AddVariable(new Variable("GroupSize", new IntData(2)));
-      GetVariable("CopySelected").GetValue<BoolData>().Data = true;
+    public TournamentSelector() : base() {
+      Parameters.Add(new ValueLookupParameter<IntData>("GroupSize", "The size of the tournament group.", new IntData(2)));
     }
 
-    /// <summary>
-    /// Copies or moves the best sub scopes from the given <paramref name="source"/> to the specified
-    /// <paramref name="target"/>.
-    /// </summary>
-    /// <exception cref="InvalidOperationException">Thrown when no source sub scopes are available.</exception>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="source">The source scope from where to copy/move the sub scopes.</param>
-    /// <param name="selected">The number of sub scopes to copy/move.</param>
-    /// <param name="target">The target scope where to add the sub scopes.</param>
-    /// <param name="copySelected">Boolean flag whether the sub scopes shall be moved or copied.</param>
-    protected override void Select(IRandom random, IScope source, int selected, IScope target, bool copySelected) {
-      IVariableInfo qualityInfo = GetVariableInfo("Quality");
-      bool maximization = GetVariableValue<BoolData>("Maximization", source, true).Data;
-      int groupSize = GetVariableValue<IntData>("GroupSize", source, true).Data;
-      for (int i = 0; i < selected; i++) {
-        if (source.SubScopes.Count < 1) throw new InvalidOperationException("No source scopes available to select.");
+    protected override void Select(ScopeList source, ScopeList target) {
+      int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
+      bool copy = CopySelectedParameter.Value.Value;
+      IRandom random = RandomParameter.ActualValue;
+      bool maximization = MaximizationParameter.ActualValue.Value;
+      List<DoubleData> qualities = new List<DoubleData>(QualityParameter.ActualValue);
+      int groupSize = GroupSizeParameter.ActualValue.Value;
 
-        IScope selectedScope = source.SubScopes[random.Next(source.SubScopes.Count)];
-        double best = selectedScope.GetVariableValue<DoubleData>(qualityInfo.FormalName, false).Data;
+      for (int i = 0; i < count; i++) {
+        int best = random.Next(source.Count);
+        int index;
         for (int j = 1; j < groupSize; j++) {
-          IScope scope = source.SubScopes[random.Next(source.SubScopes.Count)];
-          double quality = scope.GetVariableValue<DoubleData>(qualityInfo.FormalName, false).Data;
-          if (((maximization) && (quality > best)) ||
-              ((!maximization) && (quality < best))) {
-            best = quality;
-            selectedScope = scope;
+          index = random.Next(source.Count);
+          if (((maximization) && (qualities[index].Value > qualities[best].Value)) ||
+              ((!maximization) && (qualities[index].Value < qualities[best].Value))) {
+            best = index;
           }
         }
 
-        if (copySelected)
-          target.AddSubScope((IScope)selectedScope.Clone());
+        if (copy)
+          target.Add((IScope)source[best].Clone());
         else {
-          source.RemoveSubScope(selectedScope);
-          target.AddSubScope(selectedScope);
+          target.Add(source[best]);
+          source.RemoveAt(best);
+          qualities.RemoveAt(best);
         }
       }
